K =5;
MIN_VAL = 0.5;
MAX_VAL = 5.5;
b_lower = [MIN_VAL 1.5 2.5 3.5 4.5];
b_upper = [1.5 2.5 3.5 4.5 MAX_VAL];
mu_vec = 1:5;
N = 1e6; % number of samples
n_times = 1 ;

for i = 1:n_times
    for k = 1:K   
        %mu = b_lower(k) + rand() * (b_upper(k) - b_lower(k));
        %sigma = 3*rand();
        mu = mu_vec(k);
        sigma = 2.5;
        fprintf('\nTruncated normal: lower=%f, upper=%f, mean=%f, std-deviation=%f\n', b_lower(k), b_upper(k), mu, sigma);
        xx = randraw('normaltrunc',[b_lower(k),b_upper(k),mu,sigma],[N,1]);
        [ex,ex2,entropy] = compute_truncnormal_moments(mu, sigma.^(-2), b_lower(k),b_upper(k));
        fprintf('Computed: E(x) = %f, E(x.^2) = %f, entropy = %f\n', ex, ex2, entropy);
        fprintf('Empirical: E(x) = %f, E(x.^2) = %f\n', mean(xx),  mean(xx.^2));  
    end
end

[ex, ex2, entropy] = compute_truncnormal_moments(0, 1, -10, 10);
fprintf('\nChecking stats of standard gaussian with boundary [-10, 10]\nentropy above should be close to %f\n', 0.5*log(2*pi))
fprintf('Computed: E(x) = %f, E(x.^2) = %f, entropy = %f\n', ex, ex2, entropy);
