%n = 1e1;
n = 1e3;
for shape = 10.^[-3:3]
    for rate = 10.^[-3:3]
        
        x = randgamma(ones(n,1)*shape) / rate;
        
        logxbar = mean(log(x));
        xbar = mean(x);
        
        fprintf('\nTrue parameters: shape = %.3f, rate = %.3f\n', shape, rate);
        fprintf('Different initializations\n');
        for i = 1:1%10
            shape0 = rand(1);
            rate0 = rand(1);
            t_init = tic;
            [shape_est rate_est] = gamma_mle_newton(logxbar,xbar,n,shape0,rate0);
            fprintf('Init %2d, shape0 = %.3f, rate0 = %.3f, my estimates: shape = %.3f, rate = %.3f, time = %f\n', ...
                i, shape0, rate0, shape_est, rate_est, toc(t_init));
        end
        
        t_init = tic;
        [a,b] = gamma_fit(x);
        fprintf('Minka estimates: shape = %.3f, rate = %.3f, time = %f\n', a, 1/b, toc(t_init))
    end
end