clear all; close all; clc;

startup()

WRITE = 0;
nQueries = 20;
K = 5;

difficulty = 'off'
tag_template = ['toydata_regression_ml']

settings = struct();
settings.thresh = 0.1;
settings.maxIter = 1e3;
settings.EPS = 1e-15;
settings.numeric_error = 0;
settings.write = 0 %  write results if 1
settings.verbose = 2;
settings.op_dir = 'results/';
settings.compute_metrics = 0;

v = (1:K)';
b_l = v - 0.5;
b_u = v + 0.5;
for init_id = 1:1
    tag = [tag_template '_' num2str(init_id)];
    expt = tag;
    for numAvgRatingsPerQueryUrl = 3 %1:6
        
        nQueryUrls = nQueries*10;
        nLabels = numAvgRatingsPerQueryUrl * nQueryUrls;
        nLabelers = round(nLabels/10);
        
        x = zeros(nLabels,4);
        z = ceil(rand(nQueryUrls,1)*K+eps);
        x(:,1) = ceil(rand(nLabels,1)*nQueryUrls+eps);
        tmp = randperm(nLabels);
        x(tmp(1:nQueryUrls),1) = (1:nQueryUrls)'; % to ensure every qu occurs atleast once
        
        x(:,2) = ceil(rand(nLabels,1)*nLabelers+eps);
        qu2q = ceil(rand(nQueryUrls,1)*nQueries+eps);
        x(:,4) = qu2q(x(:,1)); % 4th column contains queryId
        
        tau = 1*rand(nLabelers,1);  % expected precision = 1
        
        for i = 1:nLabels
            m = x(i,1);
            n = x(i,2);
            
            % generate ordinal ratings
            p = zeros(K, 1);
            for k = 1:K
                p(k) = abs( normcdf(b_u(k), z(m), 1/sqrt(tau(n))) ...
                    - normcdf(b_l(k), z(m), 1/sqrt(tau(n))) );
            end
            p = p / sum(p);
            x(i,3) = find(sample_hist(p, 1));
            
%             % generate non-ordinal ratings
%              x(i, 3) = randn(1)/sqrt(tau(n)) + z(m);            
        end
        
        predZ = regression_ml(settings, x, nQueryUrls, nLabelers, nLabels, K, ...
            v, init_id, difficulty, expt);
        [mse, mae, corr_coef, zero_one_acc, err] = compute_metrics_simple(z, predZ);
        fprintf('mse = %.3f, mae = %.3f, corr = %.3f, zero_one_acc = %.3f\n', mse, mae, corr_coef, zero_one_acc);
        
        if WRITE
            expt = [tag '_nQueries' num2str(nQueries) '_numAvgRatingsPerQueryUrl' num2str(numAvgRatingsPerQueryUrl)];
            dlmwrite([expt '.noisyRatings'], ...
                x, 'delimiter', '\t', 'precision', 10, 'roffset', 1);
            dlmwrite([expt '.gt.quId.queryId.tsv'], ...
                [(1:nQueryUrls)' z qu2q], 'delimiter', '\t', 'precision', 10);
        end
    end
end


